From 80908e1f237f323172590c6bf6edd9d94cf42290 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Wed, 2 Nov 2022 16:54:18 +0800
Subject: [PATCH] =?UTF-8?q?=E4=BB=BB=E5=8A=A1=E5=AE=8C=E6=88=90=EF=BC=8C?=
 =?UTF-8?q?=E6=8F=90=E4=BA=A4=E4=BD=9C=E4=B8=9A?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 block.c | 87 ++++++++++++++++++++++++++++++++++++---------------------
 1 file changed, 55 insertions(+), 32 deletions(-)

diff --git a/block.c b/block.c
index 4102969..49ff9ba 100644
--- a/block.c
+++ b/block.c
@@ -387,45 +387,68 @@ ULONG SubQueueRemainLength = SUB_QUEUE_LENGTH;
 BOOL ScanInside = TRUE;
 
 
+/*
+ĺʵ SCAN ̵㷨㷨
+㷨ȿǴͷƶķȻٿƶ̡
+*/
+
+
 PREQUEST
 IopDiskSchedule(
 	VOID
 	)
-/*++
-
-
-	̵ȡڱʵ̵ִֶ㷨
-	 FCFSSSTFSCANCSCANN-Step-SCAN ȣ
-
-
-	ޡ
-
-ֵ
-	شѡһҪָ롣
-
-˵
-	̵㷨ǸݵǰͷڵĴŵ͸߳ҪʵĴŵ
-	еȵġеǰͷڵĴŵȫֱ CurrentCylinder У
-	и Cylinder 򱣴˶Ӧ߳ҪʵĴŵ
-
-	ע⣬úֻǴѡһҪ󣬶Ҫѡ
-	ƳҲҪӦ̻߳ѡ
-
---*/
 {
 	PLIST_ENTRY pListEntry;
-	PREQUEST pNextRequest;
+	PREQUEST pRequest;
+	LONG Offset;
 	
-	//
-	// FCFS (First-Come,First-Served) ̵㷨һ򵥵Ĵ̵㷨
-	// ѡеĵһ󣬴Ӷ̷߳ʴ̵Ⱥ˳еȡ
-	//
-	pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	ULONG InsideShortestDistance = 0xFFFFFFFF;
+	ULONG OutsideShortestDistance = 0xFFFFFFFF;
+	PREQUEST pNextRequest[2] = { NULL , NULL };
 	
-	//
-	// ָ
-	//
-	pNextRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+	for (pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	     pListEntry != &RequestListHead;	// ͷʱѭ
+	     pListEntry = pListEntry->Next) {
+	
+		//
+		// ָ
+		//
+		pRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+		
+		//
+		// Ӧ߳ʵĴŵ뵱ǰͷڴŵƫƣʾ
+		//
+		Offset = pRequest->Cylinder - CurrentCylinder;
+		
+		if (0 == Offset) {
+			//
+			// ߳ҪʵĴŵ뵱ǰͷڴŵͬء
+			//
+			return pRequest;
+		} else if (Offset > 0) {
+			//
+			// ¼ƶ̵߳
+			//
+			if (Offset < InsideShortestDistance) {
+		
+				InsideShortestDistance = Offset;
+				pNextRequest[1] = pRequest;
+			}
+		} else if (Offset < 0) {
+			//
+			// ¼ƶ̵߳
+			//
+			if (-Offset < OutsideShortestDistance) {
+		
+				OutsideShortestDistance = -Offset;
+				pNextRequest[0] = pRequest;
+			}
+		}
+	}
+	
+	if(!pNextRequest[ScanInside]){
+		ScanInside=!ScanInside;
+	}
 	
-	return pNextRequest;
+	return pNextRequest[ScanInside];
 }
-- 
2.34.1.windows.1

